var mqtt = require('mqtt');
var userName = '{user_name}';//用户名
var password = '{password}';//用户密码
var subscribedTopic = '{subscribed_topic}';//订阅IoT 主题
var subscribedMessage = '{subscribed_message}';//发布消息内容
var endpointIp = '{endpoint_ip}';//终端节点IP
var port = '{endpoint_port}';//终端节点端口
var protocalName = '{protocal_name}';//协议名称

var options = {
	keepalive: 60,
	username: userName,
	password: password,
	clientId: 'mqtt_client_' + new Date().getTime(),
	clean: true,
	connectTimeout: 4000
};

//IoT实例的终端节点, 通常由IP和端口号组成
var client = mqtt.connect('ws://' + endpointIp + ':' + port + '/' + protocalName, options);
if (!client) {
	console.log('连接失败, 请检查网络!');
}

client.on('error', (error) => {
	console.log('发生错误!');
});

//接收IoT实例推送给客户端的消息
client.on('message', (topic, payload) => {
	console.log('[接收][Receive message] ' + new Date() + ' | topic: ' + topic);
	console.log('[接收][Receive message] ' + new Date() + ' | payload: ' + payload);
	client.end();
});

//订阅IoT主题subscribeTopic
client.subscribe('/' + subscribedTopic, {
	qos: 0
}, (error) => {

	if (error) {
		console.log('订阅失败!');
	} else {
		console.log('[订阅][Subscribe] ' + new Date() + ' | Subscribe ' + '/' + subscribedTopic + ' successfully!');

		//在IoT主题subscribeTopic下发布一条内容为subscribedMessage的消息
		client.publish('/' + subscribedTopic, subscribedMessage, {
			qos: 0,
			retain: false
		}, (e) => {
			console.log('[发布][Publish] ' + new Date() + ' | Publish ' + subscribedMessage + ' successfully! ');
		});
	}
});